/*
 * vdctl.h
 * original code: SASANO Takayoshi
 * --- public domain, no warranty.
 */

#include <driver/driver.h>
#include <device/disk.h>

/* BTRON process$B"+"*(Bvdctl device$B$H$N$d$j$H$j$K;HMQ$9$k9=B$BN(B */
typedef	struct {
	W		cmd;			/* $B%3%^%s%I<oJL(B		(c) */
	W		start;			/* $B3+;O%;%/%?HV9f(B	(c) */
	W		size;			/* $BMW5a$7$?%;%/%??t(B	(c) */
	VP		addr;			/* $B%^%C%W$7$?%"%I%l%9(B	(r) */
	W		error;			/* $B%(%i!<%3!<%I(B		(r) */
	W		reserved[3];		/* $BM=Ls(B			    */
} VDCTL_HDR;

/* $B%X%C%@$K=q$-9~$^$l$k%3%^%s%I(B */
#define	VDCMD_EJECT	0			/* $B2>A[%\%j%e!<%`2r=|MW5a(B */
#define	VDCMD_MAP	1			/* $B2>A[%\%j%e!<%`%^%C%WMW5a(B */


/* vdctl device$B$K2>A[%\%j%e!<%`$rEPO?$9$k:]$K;HMQ$9$k9=B$BN(B */
typedef	struct {
	W		devkind;		/* $B%G%P%$%9!&%a%G%#%"<oJL(B */
	W		mapsect;		/* $B%^%C%W%;%/%??t(B(sector) */
	VP		mapaddr;		/* $B%^%C%W%"%I%l%9(B */
	W		mappos;			/* $B%^%C%W3+;O0LCV(B(sector) */
	W		cmdtmo;			/* $B%3%^%s%IBT$A;~4V(B(ms) */
	W		resptmo;		/* $B%l%9%]%s%9BT$A;~4V(B(ms) */
	DiskInfo	diskinfo;		/* $B%G%#%9%/>pJs(B */
} VDCTL_DEVINFO;


/* vdctl device$B$NB0@-%G!<%?HV9f(B */
#define	DN_VDSETDISKINFO	(-1000)		/* $B2>A[%\%j%e!<%`EPO?(B */
#define	DN_VDCLEARDISKINFO	(-2000)		/* $B2>A[%\%j%e!<%`2r=|(B */
